import naive_cosine as dct


# Quantification de F par le masque Q
#
# Entrée : une matrice de fréquence (obtenue par DCT) et un masque Q
# Sortie : nouvelle matrice quantifiée, les fréquences hautes sont "fondues" par le masque

def quantif(F, Q):
    new = F.copy()
    for i in range(len(new)):
        for j in range(len(new[0])):
            new[i][j] = round(F[i][j]/Q[i][j])
    return(new)


# Quantification inverse
#
# Entrée : matrice quantifiée
# Sortie : matrice d'origine (un peu érronée à cause de la quantification)

def reverse_quantif(quantified, Q):
    Fapp = quantified.copy()
    for i in range(len(Fapp)):
        for j in range(len(Fapp[0])):
            Fapp[i][j] = quantified[i][j] * Q[i][j]
    return(Fapp)


"""
Freq = [[1259.6249999999998, -1.0333282734264317, -12.080899722278156, -5.202897632351183, 2.1250000000000395, -1.6724303924124961, -2.7079719164466263, 1.3238449641647727], [-22.59043604867384, -17.484184984963683, -6.240475613706412, -3.1573751333367497, -2.8556653199098, -0.06945585634861473, 0.4341651476704165, -1.1855839794560339], [-10.949263949383521, -9.26239570619735, -1.575825214724766, 1.530090475777044, 0.20294853755481768, -0.9418636259697415, -0.5669417382415709, -0.06292373448959321], [-7.081555107083545, -1.9071760331998462, 0.224789667560632, 1.4538889620373716, 0.8962513174481082, -0.07987423319339015, -0.0422908405750686, 0.3315383190213428],
        [-0.625, -0.8381083589200742, 1.4698833354859069, 1.55628161791644, -0.12499999999997513, -0.6609860578562721, 0.608845612664469, 1.2752095262204408], [1.7540818213959848, -0.20285866258100782, 1.6204866133510443, -0.34243736611695397, -0.7755381437234803, 1.4759360604641767, 1.0410044136725674, -0.992962470826737], [-1.2825244507344173, -0.3599527941914591, -0.3169417382415851, -1.4600985413244505, -0.4899611118286291, 1.7348425389864133, 1.075825214724782, -0.7613475106448924], [-2.5998987210929236, 1.551852887620445, -3.7627762902215443, -1.8447577060244793, 1.8716168796703263, 1.2139452102228931, -0.5678849935122718, -0.4456400375378722]]


masque = [[16, 11, 10, 16, 24, 40, 51, 61], [12, 12, 14, 19, 26, 58, 60, 55], [14, 13, 16, 24, 40, 57, 69, 56], [14, 17, 22, 29, 51, 87, 80, 62], [
    18, 22, 37, 56, 68, 109, 103, 77], [24, 35, 55, 64, 81, 104, 113, 92], [49, 64, 78, 87, 103, 121, 120, 101], [72, 92, 95, 98, 112, 100, 103, 99]]

print(Freq)
Quant = quantif(Freq, masque)
print(Quant)
Rev = reverse_quantif(Quant, masque)


print(Rev)

CosineReal = dct.cosine_transform(dct.reverse_cosine_transform(Freq))
CosineApp = dct.cosine_transform(dct.reverse_cosine_transform(Rev))

print(CosineReal)
print(CosineApp)
"""
